package se.umu.jobsubmission.impl.informationfinder.test; 

import java.util.Iterator; 
import java.util.List; 

import se.umu.jobsubmission.impl.informationfinder.ResourceFinder; 
import se.umu.jobsubmission.impl.informationfinder.ARCResourceFinder; 

import se.umu.jobsubmission.impl.informationfinder.ARCResource; 
import se.umu.jobsubmission.impl.informationfinder.InformationFetcher; 
import se.umu.jobsubmission.impl.informationfinder.ARCInformationFetcher; 

public class TestARCResourceFinder {
    public static void main(String[] args) {
        try {

            ResourceFinder finder = new ARCResourceFinder(); 
            List resources = null; 

            if(args.length == 0) 
                resources = finder.findResources("ldap://grid.uio.no:2135", 20000); 
            else
                resources = finder.findResources(args[0], 20000); 

            if(resources == null) {
                System.out.println("No resources found"); 
                System.exit(0); 
            }

            List giises = (List) resources.get(0); 
            List clusters = (List) resources.get(1); 

            System.out.println("GIISes:"); 
            Iterator it1 = giises.iterator(); 
            while(it1.hasNext())
                System.out.println(it1.next()); 

            System.out.println("Clusters:"); 
            Iterator it2 = clusters.iterator(); 
            /*
            while(it2.hasNext())
                System.out.println(it2.next()); */

            // Flip 'em round a bit
            Object arr[] = clusters.toArray(); 
            int size = arr.length; 
            for(int i = 0; i < size; i++) {
                int nr = (int) (Math.random()*size); 
                Object tmp = arr[nr]; 
                arr[nr] = arr[i]; 
                arr[i] = tmp; 
            }
            
            for(int i = 0; i < size; i++) 
                System.out.println(arr[i]); 

            // Now, query all clusters: 
           it2 = clusters.iterator(); 
           int resourceNr = 0; 
           // while(it2.hasNext()) {
           for(int i = 0; i < size; i++) {
               InformationFetcher fetcher = new ARCInformationFetcher(); 
               System.out.println("\n --- Resource " + (++resourceNr) + " ---  \n"); 
               ARCResource resource = 
                   (ARCResource) fetcher.getInformation((String)arr[i], 20000); 
               if(resource != null) 
                   resource.printIt(); 
               else
                   System.out.println(" no information found"); 
               System.out.println("\n --- End of Resource " + resourceNr + " ---  \n"); 
           }

        } catch(Exception e) {
            System.out.println("Error:"); 
            e.printStackTrace(); 
        }
    }
}

