/*
 * Created on Apr 19, 2005
 *
 */
package se.umu.wsag.impl;

/**
 * @author tordsson
 *
 * Simple class representing a agreement decision. 
 * The decision attribute determines whether the agreement offer 
 * was granted or not, the reason states why (non-granted) offers
 * were rejected. The context can be used to pass any domain-specific
 * parameter back from the AgreementDecisionMaker to caller. 
 * In the reservation scenario, this is used to pass exact start time and
 * local ID of the reservation.  
 */
public class AgreementDecision {
	
	public boolean decision; 
	public String reason; 
	public Object context;

	/**
	 * @param decision
	 * @param reason
	 * @param context
	 */
	public AgreementDecision(boolean decision, String reason, Object context) {
		super();
		this.decision = decision;
		this.reason = reason;
		this.context = context;
	}

	/**
	 * @return Returns the decision.
	 */
	public boolean isDecision() {
		return decision;
	}
	/**
	 * @param decision The decision to set.
	 */
	public void setDecision(boolean decision) {
		this.decision = decision;
	}
	/**
	 * @return Returns the reason.
	 */
	public String getReason() {
		return reason;
	}
	/**
	 * @param reason The reason to set.
	 */
	public void setReason(String reason) {
		this.reason = reason;
	}
	/**
	 * @return Returns the context.
	 */
	public Object getContext() {
		return context;
	}
	/**
	 * @param context The context to set.
	 */
	public void setContext(Object context) {
		this.context = context;
	}
}
